'
' Copyright 2003 - Captator - de danske .NET eksperter
'

' Denne demo er p ingen mde en videnskabelig eller njagtig test - dets eneste forml er at demonstrere
' hvordan connection pooling benyttes samt, at det har en ikke uvsentlig effekt p performance.
' 
' Denne demo er til fri afbenyttelse, den er lavet som et eksempel i forbindelse med 
' artiklen "Connection pooling". Har du ikke artiklen, kan du finde den p www.captator.dk
'
' Finder du en fejl s lad vre med at sagsge os ;^)
' Fortl os i stedet for om  fejl og forslag til forbedringer p f.eks. e-mail: lykke@captator.dk 
'
' Demoen forudstter en SQL server p localhost, indeholdende standardeksemplet NorthWind,
' med end smule omskrivning af connection string og databasetilgang kan en vilkrlig database benyttes.
'
' Der foretages direkte kald til ADO.NET i denne demo, dette er IKKE best-practices. Captator anbefaler 
' ALTID at benytte et databaselag sledes at ADO.NET kald, sql-udtryk, connection strings m.v. 
' pakkes ind i selvstndige klasser / komponenter.
'
'
' BEMRK: Connection Lifetime er i denne demo sat til 10 sekunder. Dette betyder at en connection 
' skal vre mindre end 10 sekunder gammel, for at blive lagt tilbage i poolen.
' .NET frameworket checker ikke p om en connection er for gammel nr den tages ud af poolen og benyttes,
' derfor kan man godt benytte en connection, der er ldre end 10 sekunder, MEN den bliver nedlagt
' i stedet for at blive lagt tilbage i poolen efter endt brug.
'
' Her er forklaringen fra dokumentationen:
'   "When a connection is returned to the pool, its creation time is compared with the current time, 
'    and the connection is destroyed if that time span (in seconds) exceeds the value specified by 
'    Connection Lifetime."


Public Class ConnectionPoolMainForm
  Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

  Public Sub New()
    MyBase.New()

    'This call is required by the Windows Form Designer.
    InitializeComponent()

    'Add any initialization after the InitializeComponent() call

  End Sub

  'Form overrides dispose to clean up the component list.
  Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
    If disposing Then
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub

  'Required by the Windows Form Designer
  Private components As System.ComponentModel.IContainer

  'NOTE: The following procedure is required by the Windows Form Designer
  'It can be modified using the Windows Form Designer.  
  'Do not modify it using the code editor.
  Friend WithEvents Panel1 As System.Windows.Forms.Panel
  Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
  Friend WithEvents Label4 As System.Windows.Forms.Label
  Friend WithEvents lblNofDBCalls As System.Windows.Forms.Label
  Friend WithEvents GroupBox1 As System.Windows.Forms.GroupBox
  Friend WithEvents btnSameConnStringPoolingOn As System.Windows.Forms.Button
  Friend WithEvents GroupBox2 As System.Windows.Forms.GroupBox
  Friend WithEvents btnSameConnStringPoolingOff As System.Windows.Forms.Button
  Friend WithEvents btnDifferentConnStringsPoolingOff As System.Windows.Forms.Button
  Friend WithEvents btnDifferentConnStringsPoolingOn As System.Windows.Forms.Button
  Friend WithEvents txtOutputSameOff As System.Windows.Forms.TextBox
  Friend WithEvents txtOutputSameOn As System.Windows.Forms.TextBox
  Friend WithEvents txtOutputDiffOff As System.Windows.Forms.TextBox
  Friend WithEvents txtOutputDiffOn As System.Windows.Forms.TextBox
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
    Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(ConnectionPoolMainForm))
    Me.btnSameConnStringPoolingOn = New System.Windows.Forms.Button
    Me.txtOutputSameOff = New System.Windows.Forms.TextBox
    Me.lblNofDBCalls = New System.Windows.Forms.Label
    Me.Panel1 = New System.Windows.Forms.Panel
    Me.PictureBox1 = New System.Windows.Forms.PictureBox
    Me.Label4 = New System.Windows.Forms.Label
    Me.GroupBox1 = New System.Windows.Forms.GroupBox
    Me.txtOutputSameOn = New System.Windows.Forms.TextBox
    Me.btnSameConnStringPoolingOff = New System.Windows.Forms.Button
    Me.GroupBox2 = New System.Windows.Forms.GroupBox
    Me.txtOutputDiffOn = New System.Windows.Forms.TextBox
    Me.btnDifferentConnStringsPoolingOn = New System.Windows.Forms.Button
    Me.txtOutputDiffOff = New System.Windows.Forms.TextBox
    Me.btnDifferentConnStringsPoolingOff = New System.Windows.Forms.Button
    Me.Panel1.SuspendLayout()
    Me.GroupBox1.SuspendLayout()
    Me.GroupBox2.SuspendLayout()
    Me.SuspendLayout()
    '
    'btnSameConnStringPoolingOn
    '
    Me.btnSameConnStringPoolingOn.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
    Me.btnSameConnStringPoolingOn.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.btnSameConnStringPoolingOn.Location = New System.Drawing.Point(8, 128)
    Me.btnSameConnStringPoolingOn.Name = "btnSameConnStringPoolingOn"
    Me.btnSameConnStringPoolingOn.Size = New System.Drawing.Size(112, 64)
    Me.btnSameConnStringPoolingOn.TabIndex = 0
    Me.btnSameConnStringPoolingOn.Text = "Med connection pooling"
    '
    'txtOutputSameOff
    '
    Me.txtOutputSameOff.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                Or System.Windows.Forms.AnchorStyles.Left) _
                Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
    Me.txtOutputSameOff.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.txtOutputSameOff.Location = New System.Drawing.Point(128, 24)
    Me.txtOutputSameOff.Multiline = True
    Me.txtOutputSameOff.Name = "txtOutputSameOff"
    Me.txtOutputSameOff.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
    Me.txtOutputSameOff.Size = New System.Drawing.Size(640, 96)
    Me.txtOutputSameOff.TabIndex = 1
    Me.txtOutputSameOff.Text = ""
    '
    'lblNofDBCalls
    '
    Me.lblNofDBCalls.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.lblNofDBCalls.Location = New System.Drawing.Point(16, 56)
    Me.lblNofDBCalls.Name = "lblNofDBCalls"
    Me.lblNofDBCalls.Size = New System.Drawing.Size(664, 24)
    Me.lblNofDBCalls.TabIndex = 4
    Me.lblNofDBCalls.Text = "Hver demo foretager de samme {0} databasekald, men blot med forskellige connectio" & _
    "n strings."
    '
    'Panel1
    '
    Me.Panel1.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
    Me.Panel1.BackColor = System.Drawing.Color.White
    Me.Panel1.Controls.Add(Me.PictureBox1)
    Me.Panel1.Location = New System.Drawing.Point(0, 0)
    Me.Panel1.Name = "Panel1"
    Me.Panel1.Size = New System.Drawing.Size(792, 48)
    Me.Panel1.TabIndex = 7
    '
    'PictureBox1
    '
    Me.PictureBox1.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
    Me.PictureBox1.BackColor = System.Drawing.Color.White
    Me.PictureBox1.Image = CType(resources.GetObject("PictureBox1.Image"), System.Drawing.Image)
    Me.PictureBox1.Location = New System.Drawing.Point(696, 8)
    Me.PictureBox1.Name = "PictureBox1"
    Me.PictureBox1.Size = New System.Drawing.Size(75, 35)
    Me.PictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize
    Me.PictureBox1.TabIndex = 4
    Me.PictureBox1.TabStop = False
    '
    'Label4
    '
    Me.Label4.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.Label4.Location = New System.Drawing.Point(16, 80)
    Me.Label4.Name = "Label4"
    Me.Label4.Size = New System.Drawing.Size(664, 24)
    Me.Label4.TabIndex = 8
    Me.Label4.Text = "Bemrk: Nr applikationen starter oprettes 1 database connection (se hvorfor i ko" & _
    "den)"
    '
    'GroupBox1
    '
    Me.GroupBox1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                Or System.Windows.Forms.AnchorStyles.Left) _
                Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
    Me.GroupBox1.Controls.Add(Me.txtOutputSameOn)
    Me.GroupBox1.Controls.Add(Me.btnSameConnStringPoolingOff)
    Me.GroupBox1.Controls.Add(Me.btnSameConnStringPoolingOn)
    Me.GroupBox1.Controls.Add(Me.txtOutputSameOff)
    Me.GroupBox1.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.GroupBox1.Location = New System.Drawing.Point(8, 104)
    Me.GroupBox1.Name = "GroupBox1"
    Me.GroupBox1.Size = New System.Drawing.Size(776, 224)
    Me.GroupBox1.TabIndex = 9
    Me.GroupBox1.TabStop = False
    Me.GroupBox1.Text = "Samme connectionstring"
    '
    'txtOutputSameOn
    '
    Me.txtOutputSameOn.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
    Me.txtOutputSameOn.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.txtOutputSameOn.Location = New System.Drawing.Point(128, 120)
    Me.txtOutputSameOn.Multiline = True
    Me.txtOutputSameOn.Name = "txtOutputSameOn"
    Me.txtOutputSameOn.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
    Me.txtOutputSameOn.Size = New System.Drawing.Size(640, 96)
    Me.txtOutputSameOn.TabIndex = 3
    Me.txtOutputSameOn.Text = ""
    '
    'btnSameConnStringPoolingOff
    '
    Me.btnSameConnStringPoolingOff.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.btnSameConnStringPoolingOff.Location = New System.Drawing.Point(8, 32)
    Me.btnSameConnStringPoolingOff.Name = "btnSameConnStringPoolingOff"
    Me.btnSameConnStringPoolingOff.Size = New System.Drawing.Size(112, 64)
    Me.btnSameConnStringPoolingOff.TabIndex = 2
    Me.btnSameConnStringPoolingOff.Text = "Uden connection pooling"
    '
    'GroupBox2
    '
    Me.GroupBox2.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
    Me.GroupBox2.Controls.Add(Me.txtOutputDiffOn)
    Me.GroupBox2.Controls.Add(Me.btnDifferentConnStringsPoolingOn)
    Me.GroupBox2.Controls.Add(Me.txtOutputDiffOff)
    Me.GroupBox2.Controls.Add(Me.btnDifferentConnStringsPoolingOff)
    Me.GroupBox2.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.GroupBox2.Location = New System.Drawing.Point(8, 336)
    Me.GroupBox2.Name = "GroupBox2"
    Me.GroupBox2.Size = New System.Drawing.Size(776, 224)
    Me.GroupBox2.TabIndex = 10
    Me.GroupBox2.TabStop = False
    Me.GroupBox2.Text = "Forskellige connectionstrings"
    '
    'txtOutputDiffOn
    '
    Me.txtOutputDiffOn.Anchor = CType(((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
    Me.txtOutputDiffOn.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.txtOutputDiffOn.Location = New System.Drawing.Point(128, 120)
    Me.txtOutputDiffOn.Multiline = True
    Me.txtOutputDiffOn.Name = "txtOutputDiffOn"
    Me.txtOutputDiffOn.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
    Me.txtOutputDiffOn.Size = New System.Drawing.Size(640, 96)
    Me.txtOutputDiffOn.TabIndex = 3
    Me.txtOutputDiffOn.Text = ""
    '
    'btnDifferentConnStringsPoolingOn
    '
    Me.btnDifferentConnStringsPoolingOn.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
    Me.btnDifferentConnStringsPoolingOn.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.btnDifferentConnStringsPoolingOn.Location = New System.Drawing.Point(8, 128)
    Me.btnDifferentConnStringsPoolingOn.Name = "btnDifferentConnStringsPoolingOn"
    Me.btnDifferentConnStringsPoolingOn.Size = New System.Drawing.Size(112, 64)
    Me.btnDifferentConnStringsPoolingOn.TabIndex = 2
    Me.btnDifferentConnStringsPoolingOn.Text = "Med connection pooling"
    '
    'txtOutputDiffOff
    '
    Me.txtOutputDiffOff.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
    Me.txtOutputDiffOff.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.txtOutputDiffOff.Location = New System.Drawing.Point(128, 24)
    Me.txtOutputDiffOff.Multiline = True
    Me.txtOutputDiffOff.Name = "txtOutputDiffOff"
    Me.txtOutputDiffOff.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
    Me.txtOutputDiffOff.Size = New System.Drawing.Size(640, 96)
    Me.txtOutputDiffOff.TabIndex = 1
    Me.txtOutputDiffOff.Text = ""
    '
    'btnDifferentConnStringsPoolingOff
    '
    Me.btnDifferentConnStringsPoolingOff.Font = New System.Drawing.Font("Microsoft Sans Serif", 11.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Me.btnDifferentConnStringsPoolingOff.Location = New System.Drawing.Point(8, 32)
    Me.btnDifferentConnStringsPoolingOff.Name = "btnDifferentConnStringsPoolingOff"
    Me.btnDifferentConnStringsPoolingOff.Size = New System.Drawing.Size(112, 64)
    Me.btnDifferentConnStringsPoolingOff.TabIndex = 0
    Me.btnDifferentConnStringsPoolingOff.Text = "Uden connection pooling"
    '
    'ConnectionPoolMainForm
    '
    Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
    Me.ClientSize = New System.Drawing.Size(792, 566)
    Me.Controls.Add(Me.GroupBox2)
    Me.Controls.Add(Me.GroupBox1)
    Me.Controls.Add(Me.Label4)
    Me.Controls.Add(Me.Panel1)
    Me.Controls.Add(Me.lblNofDBCalls)
    Me.MaximumSize = New System.Drawing.Size(2048, 600)
    Me.MinimumSize = New System.Drawing.Size(800, 600)
    Me.Name = "ConnectionPoolMainForm"
    Me.Text = "Connection Pooling Demo (VB.NET version)"
    Me.Panel1.ResumeLayout(False)
    Me.GroupBox1.ResumeLayout(False)
    Me.GroupBox2.ResumeLayout(False)
    Me.ResumeLayout(False)

  End Sub

#End Region

  '"Connection Lifetime" sttes til 10 sekunder, 
  '      for at vi kan observere at pools bliver "ryddet op". Default er "Connection Lifetime=0", hvilket betyder maksimum lifetime;
  '      (der er ikke nogen prcis beskrivelse af hvad dette betyder, men formodentligt betyder det at der ingen timeout er)
  Private Const _connStringUsingPool As String = "Data Source=localhost;User Id=sa;Password=;Database=NorthWind;Connection Lifetime=10"

  'Pooling er default slet til ("Pooling=yes"),
  '      og det er derfor kun ndvendigt at angive dette, hvis pooling nskes slet fra
  Private Const _connStringNoPool As String = "Data Source=localhost;User Id=sa;Password=;Database=NorthWind;Pooling=no"

  Private Const _loopLimit As Integer = 40

  Private _sql As String = "SELECT COUNT(*) FROM Customers"

  Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    lblNofDBCalls.Text = String.Format(lblNofDBCalls.Text, _loopLimit)

    ' Kald til performance counters fejler, hvis der endnu ikke er bnet noget DB connection.
    ' Ved at oprette en db connection kan performance counters kaldes frst i hver enkelt demo uden at der opstr exceptions.
    QuerySameConnectionString(_connStringUsingPool)

  End Sub

  Private Sub QuerySameConnectionString(ByVal connString As String)

    ' Denne test demonstrerer, at der rent faktisk sker connection pooling, hvis strengen er ens fra gang til gang.

    For n As Integer = 1 To _loopLimit

      Dim _conn As New System.Data.SqlClient.SqlConnection(connString)

      _conn.Open()

      Dim cmd As New System.Data.SqlClient.SqlCommand(_sql, _conn)

      Dim count As Integer = CType(cmd.ExecuteScalar(), Integer)

      _conn.Close()
      _conn = Nothing

    Next

  End Sub

  Private Sub QueryDifferentConnectionString(ByVal connString As String)

    ' Denne test demonstrerer, at nr connection strengen er forskellig fra gang til gang, s placeres
    ' hver connection i sin egen connection pool. Hvis connection strengen ALTID er forskellige fra gang
    ' til gang er det faktisk bedre at sl connection pooling fra, da connection pooling ogs i sig selv
    ' skaber et lille overhead, som frst "vindes hjem igen" nr connectionen genbruges fra poolen.

    For n As Integer = 1 To _loopLimit

      Dim _conn As New System.Data.SqlClient.SqlConnection(connString + Microsoft.VisualBasic.Strings.StrDup(n, " "))

      _conn.Open()

      Dim cmd As New System.Data.SqlClient.SqlCommand(_sql, _conn)

      Dim count As Integer = CType(cmd.ExecuteScalar(), Integer)

      _conn.Close()
      _conn = Nothing

    Next

  End Sub

  Private Function ShowPerformanceCounterHeader() As String
    Dim s As String
    s = "|    Time   |------------- Number of current ------------------ |  Peak number of  |" + vbCrLf
    s += "|           |connection pools|all connections|pooled connections|pooled connections|" + vbCrLf
    Return s
  End Function

  Private Function ShowPerformanceCounters(ByVal time As Long) As String

    Dim pc As New System.Diagnostics.PerformanceCounter
    Dim c1, c2, c3, c4 As Single

    pc.CategoryName = ".NET CLR Data"
    pc.MachineName = "127.0.0.1"
    pc.InstanceName = System.Windows.Forms.Application.ProductName

    pc.CounterName = "SqlClient: Current # connection pools"
    c1 = pc.NextValue()
    pc.CounterName = "SqlClient: Current # pooled and nonpooled connections"
    c2 = pc.NextValue()
    pc.CounterName = "SqlClient: Current # pooled connections"
    c3 = pc.NextValue()
    pc.CounterName = "SqlClient: Peak # pooled connections"
    c4 = pc.NextValue()

    Return String.Format("|{0,7} ms |{1,12}    |{2,12}   |{3,15}   |{4,15}   |" + vbCrLf, time, c1, c2, c3, c4)

  End Function

  Private Sub btnSameConnStringPoolingOff_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSameConnStringPoolingOff.Click

    Dim startTime As Long

    txtOutputSameOff.Text = ShowPerformanceCounterHeader()
    txtOutputSameOff.Text += ShowPerformanceCounters(0)
    txtOutputSameOff.Text += " Udfr test ..." + vbCrLf

    startTime = System.Environment.TickCount
    QuerySameConnectionString(_connStringNoPool)

    txtOutputSameOff.Text += ShowPerformanceCounters(System.Environment.TickCount - startTime)

  End Sub

  Private Sub btnSameConnStringPoolingOn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSameConnStringPoolingOn.Click

    Dim startTime As Long

    txtOutputSameOn.Text = ShowPerformanceCounterHeader()
    txtOutputSameOn.Text += ShowPerformanceCounters(0)
    txtOutputSameOn.Text += " Udfr test ..." + vbCrLf

    startTime = System.Environment.TickCount
    QuerySameConnectionString(_connStringUsingPool)

    txtOutputSameOn.Text += ShowPerformanceCounters(System.Environment.TickCount - startTime)

  End Sub

  Private Sub btnDifferentConnStringsPoolingOff_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDifferentConnStringsPoolingOff.Click

    Dim startTime As Long

    txtOutputDiffOff.Text = ShowPerformanceCounterHeader()
    txtOutputDiffOff.Text += ShowPerformanceCounters(0)
    txtOutputDiffOff.Text += " Udfr test ..." + vbCrLf

    startTime = System.Environment.TickCount
    QueryDifferentConnectionString(_connStringNoPool)

    txtOutputDiffOff.Text += ShowPerformanceCounters(System.Environment.TickCount - startTime)

  End Sub

  Private Sub btnDifferentConnStringsPoolingOn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDifferentConnStringsPoolingOn.Click

    Dim startTime As Long

    txtOutputDiffOn.Text = ShowPerformanceCounterHeader()
    txtOutputDiffOn.Text += ShowPerformanceCounters(0)
    txtOutputDiffOn.Text += " Udfr test ..." + vbCrLf

    startTime = System.Environment.TickCount
    QueryDifferentConnectionString(_connStringUsingPool)

    txtOutputDiffOn.Text += ShowPerformanceCounters(System.Environment.TickCount - startTime)

  End Sub

End Class